#
# This file is auto-generated. ***ANY*** changes here will be lost
#

package Errno;
use vars qw(@EXPORT_OK %EXPORT_TAGS @ISA $VERSION %errno $AUTOLOAD);
use Exporter ();
use Tie::Hash;
use Config;
use strict;

$Config{'myarchname'} eq "i386-freebsd" or
	die "Errno architecture (i386-freebsd) does not match executable architecture ($Config{'myarchname'})";

$VERSION = "1.02";
@ISA = qw(Exporter Tie::StdHash);

%errno = (
	EPERM           =>     1,
	ENOENT          =>     2,
	ESRCH           =>     3,
	EINTR           =>     4,
	EIO             =>     5,
	ENXIO           =>     6,
	E2BIG           =>     7,
	ENOEXEC         =>     8,
	EBADF           =>     9,
	ECHILD          =>    10,
	EDEADLK         =>    11,
	ENOMEM          =>    12,
	EACCES          =>    13,
	EFAULT          =>    14,
	ENOTBLK         =>    15,
	EBUSY           =>    16,
	EEXIST          =>    17,
	EXDEV           =>    18,
	ENODEV          =>    19,
	ENOTDIR         =>    20,
	EISDIR          =>    21,
	EINVAL          =>    22,
	ENFILE          =>    23,
	EMFILE          =>    24,
	ENOTTY          =>    25,
	ETXTBSY         =>    26,
	EFBIG           =>    27,
	ENOSPC          =>    28,
	ESPIPE          =>    29,
	EROFS           =>    30,
	EMLINK          =>    31,
	EPIPE           =>    32,
	EDOM            =>    33,
	ERANGE          =>    34,
	EAGAIN          =>    35,
	EWOULDBLOCK     =>    35,
	EINPROGRESS     =>    36,
	EALREADY        =>    37,
	ENOTSOCK        =>    38,
	EDESTADDRREQ    =>    39,
	EMSGSIZE        =>    40,
	EPROTOTYPE      =>    41,
	ENOPROTOOPT     =>    42,
	EPROTONOSUPPORT =>    43,
	ESOCKTNOSUPPORT =>    44,
	EOPNOTSUPP      =>    45,
	EPFNOSUPPORT    =>    46,
	EAFNOSUPPORT    =>    47,
	EADDRINUSE      =>    48,
	EADDRNOTAVAIL   =>    49,
	ENETDOWN        =>    50,
	ENETUNREACH     =>    51,
	ENETRESET       =>    52,
	ECONNABORTED    =>    53,
	ECONNRESET      =>    54,
	ENOBUFS         =>    55,
	EISCONN         =>    56,
	ENOTCONN        =>    57,
	ESHUTDOWN       =>    58,
	ETOOMANYREFS    =>    59,
	ETIMEDOUT       =>    60,
	ECONNREFUSED    =>    61,
	ELOOP           =>    62,
	ENAMETOOLONG    =>    63,
	EHOSTDOWN       =>    64,
	EHOSTUNREACH    =>    65,
	ENOTEMPTY       =>    66,
	EPROCLIM        =>    67,
	EUSERS          =>    68,
	EDQUOT          =>    69,
	ESTALE          =>    70,
	EREMOTE         =>    71,
	EBADRPC         =>    72,
	ERPCMISMATCH    =>    73,
	EPROGUNAVAIL    =>    74,
	EPROGMISMATCH   =>    75,
	EPROCUNAVAIL    =>    76,
	ENOLCK          =>    77,
	ENOSYS          =>    78,
	EFTYPE          =>    79,
	EAUTH           =>    80,
	ELAST           =>    81,
	ENEEDAUTH       =>    81,
);
@EXPORT_OK = keys %errno;

%EXPORT_TAGS = (
    POSIX => [qw(
	E2BIG EACCES EADDRINUSE EADDRNOTAVAIL EAFNOSUPPORT EAGAIN EALREADY
	EBADF EBUSY ECHILD ECONNABORTED ECONNREFUSED ECONNRESET EDEADLK
	EDESTADDRREQ EDOM EDQUOT EEXIST EFAULT EFBIG EHOSTDOWN EHOSTUNREACH
	EINPROGRESS EINTR EINVAL EIO EISCONN EISDIR ELOOP EMFILE EMLINK
	EMSGSIZE ENAMETOOLONG ENETDOWN ENETRESET ENETUNREACH ENFILE ENOBUFS
	ENODEV ENOENT ENOEXEC ENOLCK ENOMEM ENOPROTOOPT ENOSPC ENOSYS ENOTBLK
	ENOTCONN ENOTDIR ENOTEMPTY ENOTSOCK ENOTTY ENXIO EOPNOTSUPP EPERM
	EPFNOSUPPORT EPIPE EPROCLIM EPROTONOSUPPORT EPROTOTYPE ERANGE EREMOTE
	EROFS ESHUTDOWN ESOCKTNOSUPPORT ESPIPE ESRCH ESTALE ETIMEDOUT
	ETOOMANYREFS ETXTBSY EUSERS EWOULDBLOCK EXDEV
    )]
);


sub AUTOLOAD {
    my($constname);
    ($constname = $AUTOLOAD) =~ s/.*:://;

    unless(exists $errno{$constname}) {
	require Carp;
	Carp::croak("Your vendor has not defined errno $constname, used");
    }

    eval "sub $constname () { $errno{$constname} }";

    goto &$AUTOLOAD;
}

sub TIEHASH { bless \%errno } 

sub FETCH {
    my ($self, $errname) = @_;
    if (exists $self->{$errname} ) {
        return $! == $self->{$errname};
    }
    require Carp;
    Carp::confess("No errno $errname");
} 

sub STORE {
    require Carp;
    Carp::confess "ERRNO hash is read only!";
}

sub unimport { untie(%!)  }

sub import { 
    my $spec;
    tie %!,     __PACKAGE__;
    foreach $spec (@_) {
        if($spec eq ':POSIX') {
	    my $err;
	    foreach $err (@{$EXPORT_TAGS{POSIX}}) {
		eval "sub $err () { $errno{$err} }";
	    }
	}
	elsif($spec =~ m:^/(.*)/$:) {
	    my $pat = $1;
	    my $err;
	    foreach $err (@EXPORT_OK) {
		eval "sub $spec () { $errno{$spec} }"
		    if $err =~ /\Q$pat\E/;
		
	    }
	}
	elsif(exists $errno{$spec} && !defined(&{$spec})) {
	    eval "sub $spec () { $errno{$spec} }";
	}
    }
    $_[0]->export_to_level(1, @_);
}

*DELETE = *CLEAR = \&STORE;

tie %!,     __PACKAGE__;

1;
__END__

=head1 NAME

Errno - System errno constants

=head1 SYNOPSIS

    use Errno qw(EINTR EIO :POSIX);

=head1 DESCRIPTION

C<Errno> defines and conditionally exports all the error constants
defined in your system C<errno.h> include file. It has a single export
tag, C<:POSIX>, which will export all POSIX defined error numbers.

C<Errno> also makes C<%!> magic such that each element of C<%!> has a non-zero
value only if C<$!> is set to that value, eg

    use Errno;
    
    unless (open(FH, "/fangorn/spouse")) {
        if ($!{ENOENT}) {
            warn "Get a wife!\n";
        } else {
            warn "This path is barred: $!";
        } 
    } 

=head1 AUTHOR

Graham Barr <gbarr@pobox.com>

=head1 COPYRIGHT

Copyright (c) 1997-8 Graham Barr. All rights reserved.
This program is free software; you can redistribute it and/or modify it
under the same terms as Perl itself.

=cut

